/*
 * Copyright (C) 2021 Jonathan Certes
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdint.h>

/** symbols that are defined in the linker script. **/
extern int __ex_stack_low;
extern int __ex_stack_top;
extern int __sw_low;

/******************************************************************************/

int main(
  void
) {
  void * theBramAddress = (void *)(0x40000000);

  /* execution of code from the BRAM (indirect branch because "why not?") */
  __asm__ __volatile__("nop");
  __asm__ __volatile__("mov r1, %0" :: "r"(theBramAddress));
  __asm__ __volatile__("mov lr, pc");
  __asm__ __volatile__("mov pc, r1");

  __asm__ __volatile__("__my_breakpoint:");

  /* execution of code from the BRAM with a non-aligned branch destination:
   * causes a prefetch abort exception. */
  __asm__ __volatile__("nop");
  __asm__ __volatile__("movw r1, #0x00c0");
  __asm__ __volatile__("movt r1, #0x4000");
  __asm__ __volatile__("mov lr, pc");
  __asm__ __volatile__("bx r1");

  while (1) {
    // do nothing
  }

  return 0;
}

